/*
 * MosP - Mind Open Source Project         http://www.mosp.jp/
 * Copyright (C) 1987-2009 MIND Co., Ltd.  http://www.e-mind.co.jp/
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
package jp.mosp.payroll.action;

import java.util.Date;

import jp.mosp.common.MosPAction;
import jp.mosp.common.common.MospConst;
import jp.mosp.common.common.MospException;
import jp.mosp.common.common.MospUtility;
import jp.mosp.common.part.PartManager;

import jp.mosp.payroll.dao.MKintaiKeisanDao;
import jp.mosp.payroll.dto.MKintaiKeisanDto;
import jp.mosp.payroll.vo.AttendanceCalculateStartCardVo;

public class AttendanceCalculateStartCardAction extends MosPAction {

	// コマンド
	private static final String CMD_START_CARD_SHOW 	= "P1020";
	private static final String CMD_START_CARD_UPDATE = "P1021";

	// フィールド
	private MKintaiKeisanDto dto;

	/**
	 * コンストラクタ
	 */
	public AttendanceCalculateStartCardAction() {
		super();
	}

	/**
	 * アクション
	 */
	public void action() throws Exception {
		// DBコネクション取得
		getConnection();
		// PAYROLL権限確認
		confirmPayrollAuth();
		// VOの取得
		AttendanceCalculateStartCardVo vo = getInitVo();
		init(vo);
		// コマンド毎の処理
		if (cmd.equals(CMD_START_CARD_SHOW)) {
			vo.setDefaultValues();
			// 表示
			show(vo);
		} else if (cmd.equals(CMD_START_CARD_UPDATE)) {
			vo.setParams(request);
			// 更新
			update(vo);
			// 表示
			show(vo);
		} else {
			throw new MospException(MospConst.EX_CMD_INVALID);
		}
	}

	protected AttendanceCalculateStartCardVo getInitVo() {
		return new AttendanceCalculateStartCardVo();
	}

	/**
	 * 初期処理
	 * @param vo			対象VO
	 * @throws Exception
	 */
	protected void init(AttendanceCalculateStartCardVo vo) throws Exception {
		vo.initVo(cfg, msg, cmd, aspUser, user);
		// VO及びフォワード先URLの設定
		setVo(vo);
		setUrl(vo.getRetUrl());
		// 勤怠計算対象年月取得
		Date current = getCalcMonth();
		// 年度リスト取得
		vo.aryPltKTnen = util.getYearArray(MospUtility.getYear(current), 1, 1);
		// 月リスト取得
		vo.aryPltKTtuki = util.getMonthArray();
		// DTOの取得
		Object obj = session.getAttribute(MospConst.ATT_DTO);
		dto = obj instanceof MKintaiKeisanDto ? (MKintaiKeisanDto)obj : null;
	}

	/**
	 * 設定項目検索
	 * @param vo Voインスタンス
	 * @throws Exception
	 */
	protected void show(AttendanceCalculateStartCardVo vo) throws Exception {
		dto = PartManager.calculate(partInfo()).findForCalc();
		if (chkExistDto(dto)) {
			// 計算対象年月をセット
			vo.setPltKTnen(String.valueOf(dto.getKTNen()));
			vo.setPltKTtuki(String.valueOf(dto.getKTTuki()));
		} else {
			// 現在の年月をセット
			vo.setPltKTnen(String.valueOf(MospUtility.getYear(util.getSystemDate())));
			vo.setPltKTtuki(String.valueOf(MospUtility.getMonth(util.getSystemDate())));
		}
		// モード設定
		vo.setMode(AttendanceCalculateStartCardVo.MODE_UPDATE);
		// セッションにDTOをセット
		session.setAttribute(MospConst.ATT_DTO, dto);
	}	

	/**
	 * データ更新
	 * @param vo 対象VO
	 * @throws Exception
	 */
	protected void update(AttendanceCalculateStartCardVo vo) throws Exception {
		// DAOの準備
		MKintaiKeisanDao dao = new MKintaiKeisanDao();
		dao.initDao(cfg, cmd, aspUser, user, conn);
		if (dto == null) {
			dto = new MKintaiKeisanDto();
		}
		// 更新前データをＧＥＴ
		MKintaiKeisanDto formerDto = dao.findForUpdate();
		// VOの値をDTOにセット
		// 入力日付
		Date change = util.getFirstDateOfMonth(vo.getPltKTnen(), vo.getPltKTtuki());
		vo.setPltKTnen(String.valueOf(MospUtility.getYear(change)));
		vo.setPltKTtuki(String.valueOf(MospUtility.getMonth(change)));
		// 更新する前にdtoが存在するかどうかをチェック
		if (chkExistDto(formerDto)) {
			// 集計日付
			Date current = util.getFirstDateOfMonth(formerDto.getKTNen(), formerDto.getKTTuki());
			// パラメータの妥当性確認
			vo.validate(formerDto, current, change);
			// 削除
			dao.delete(formerDto);
		}
		// 変更値をDTOにセット
		vo.setDtoFields(dto);
		// 給与計算日をセット
		dto.setKSNen(MospUtility.getYear(getCalcPayment(change)));
		dto.setKSTuki(MospUtility.getMonth(getCalcPayment(change)));
		dto.setKShi(MospUtility.getDay(getCalcPayment(change)));
		// 登録	
		dao.insert(dto);
		// DTOの再取得
		MKintaiKeisanDto retDto = dao.findForKey(String.valueOf(dto.getKTNen()));
		chkUpdate(retDto);
		// メッセージ設定
		vo.setMessage(MospUtility.getMessage(msg, MospConst.MSG_UPDATE, ""));
		// コミット
		commit();
	}	

}
